/* MiscSpaceMouseFrontend.h				 
 *
 * This object deals with get GUI we need to do all the settings.
 * It does not really handle the data. It only controls the views and
 * graphical controls and work with the main MiscSwapView.
 *
 * Usage: Don't use it.
 *		  The GUI just calls all the methods we provide here and passes them
 *		  to the driver...no checks here ! The driver does that anyway.
 *
 * Written by: 		Thomas Engel
 * Created:    		09.04.1994 (Copyleft)
 * Last modified: 	15.04.1994
 */

#import <misckit/MiscSwapContentsController.h>

@interface MiscSpaceMouseFrontend:MiscSwapContentsController
{
	id	mouseDriver;

	id	privateSwapView;
	id	connectView;
	id	settingsView;

	id	portField;

	id	rotModeSwitch;
	id	transModeSwitch;
	id	domModeSwitch;
	
	id	transQualitySlider;
	id	transQualityField;
	id	rotQualitySlider;
	id	rotQualityField;
	id	nullRadiusSlider;
	id	nullRadiusField;
	id	minDataRateSlider;
	id	minDataRateField;
	id	maxDataRateSlider;
	id	maxDataRateField;
	id	scaleSlider;
	id	scaleField;
	id	scaleRationSlider;
	id	scaleRationField;
}

- revert:sender;
- usePortA:sender;
- usePortB:sender;
- useCustomPort:sender;

- connect:sender;
- disconnect:sender;

- takeTransModeFrom:sender;
- takeRotModeFrom:sender;
- takeDomModeFrom:sender;

- takeRotQualityFrom:sender;
- takeTransQualityFrom:sender;
- takeScaleFrom:sender;
- takeScaleRationFrom:sender;
- takeNullRadiusFrom:sender;
- takeMinDataRateFrom:sender;
- takeMaxDataRateFrom:sender;

@end

/*
 * History: 15.04.94 Included all the settings.
 *
 *			09.04.94 First codeing done.
 *
 *
 * Bugs: - Not very likely.
 */