/* MiscVirtual3DMouseFrontend.h				 
 *
 * This object deals with the GUI we need to do all the settings.
 * It is the frontend to the slider or trackPad based 3DMouse system.
 * Basically intended for testing a custom app without owning a real 3Dmouse.
 *
 * Usage: Don't use it.
 *		  The GUI just calls all the methods we provide here and passes them
 *		  to the driver.
 *		  The driver is a basic Misc3DMouseDriver.
 *
 *
 * Written by: 		Thomas Engel
 * Created:    		09.04.1994 (Copyleft)
 * Last modified: 	14.04.1994
 */

#import <misckit/MiscSwapContentsController.h>

@interface MiscVirtual3DMouseFrontend:MiscSwapContentsController
{
	id	mouseDriver;
	
	id	aSlider;
	id	bSlider;
	id	cSlider;
	id	rotValue;
	id	negRotRange;
	id	xSlider;
	id	ySlider;
	id	zSlider;
	id	transValue;
	id	negTransRange;
	id	modeLock;
	
	float	lastSliderValue;
}

- revert:sender;

- xRotation:sender;
- yRotation:sender;
- zRotation:sender;
- xTranslation:sender;
- yTranslation:sender;
- zTranslation:sender;

- switchLocking:sender;
- takeRotationRangeFrom:sender;
- takeTranslationRangeFrom:sender;

- (void)transformationWillStart:sender;
- (void)transformationDidEnd:sender;

@end

/*
 * History: 14.04.94 Really got it going.
 *
 *			09.04.94 First codeing done.
 *
 *
 * Bugs: - Not very likely.
 */